

# TF2 Soldier Mod

Adds the Soldier from TF2, ready for any war that comes his way.


# Overview

The Soldier is a mobile survivor that can use his tools to reposition himself, or aid his allies.


# About
This mod is a work in progress! 
My experience with the mod creation process is very limited, so *expect jank.*
Network functionality hasn't been tested much, so multiplayer may not function as intended.

![SoldierOverview](https://i.imgur.com/mvkc1bb.png)
Something weird or unexpected happen? Have some feedback regarding balance, ideas, or general questions? Feel free to contact and tell me!

# To Do:
- Add additional skins
- Test networking more thoroughly
- Make Rocket Jumping more stable, as it interacts oddly with slopes and certain map geometry
- Add the 'Speed Down' sound when the Concheror Buff expires
- Make things look more pretty
- Clean up code/implementations
- Tap into the limitless potential of alternate weapons

# Known Issues:
- Rocket Jumping can behave somewhat jankily.
	-  This mostly applies to Rocket Jumping on slopes or off of enemies, and it gives a *lot* of speed. Be careful, or watch for fall damage!
- Animations are somewhat janky
- Certain animations may be missing in multiplayer. The player should be able to see them, but not others.
- Rocket Projectiles might not line up with their "physical forms" exactly in multiplayer. (i.e., the rocket can look like it hit for no damage, when it actually misses)
- Certain sounds may be missing in multiplayer.

# Special Thanks
- Rob for the Henry Template	
- wellme for Quake/Source movement via Mint Tea
- The RoR2 Modding Discord	
- Valve / Team Fortress 2 Team	

# Contact Me
- Discord: Lemner#4765	

# Changelog  
- `1.0.1`
	- **General**
		- Slightly boosted the force of Rocket Jumps
	- **Air Strike**	
		- Increased the damage dealt (400% -> 425%)
	- **Manntreads**
		- Greatly increased the damage dealt (50% - 1500% -> 1500% - 4000%)
		- Changed the damage falloff calculation (SweetSpot -> Linear), should yield more consistent numbers
		- Increased the velocity threshold required for activation
- `1.0.0`
	- Quake/Source-like movement baked into Soldier, courtesy of the wellme and the Mint Tea mod! Features:
		- Bunnyhopping to conserve momentum
		- Air Strafing changes
		- Air Acceleration changes
	- Added new weapons!
		- Primary
			- **Beggars Bazooka**: Charge up and fire up to 3 rockets! Complete with Overload Jumping.
			- **Rocket Jumper**: Fire a rocket doing no damage to enemies or yourself!
			- **Air Strike**: Fire weaker rockets, but fire faster when rocket jumping! Gain a higher clip size as you get kills!
		- Secondary
			- **Manntreads**: No direct attack, but damage enemies when landing on/near them and moving fast enough! Also take no fall damage!
		- Utility
			- **Base Jumper**: Toggle a parachute that slows your descent!
		- Special:
			- **Half Zatoichi**: Swing a katana that heals you when hitting at least one enemy!
	- Added a new skin! Enjoy being BLU Soldier! 
	- Tweaks!
		- Rocket Launcher
			- Deals less knockback to enemies, so they slide around less on the ground.
			- Tweaked the blast force from rocket jumping a bit to compensate for the Source movement.
			- Lowered the speed of rockets slightly.
		- Concheror
			- No longer actionable (but it is still mobile)
		- Market Gardener
			- No longer pops you up when hitting an enemy when airborne.
		- Visuals/Sounds
			-  Fixed bugs around Soldier's model, such as:
				- Made Soldier and his weapons less shiny
				- Shield/freeze/tar effects being missing
				- Soldier being visible when he shouldn't be (e.g. Teleporting, using Strides of Heresy)
				- Aligned bubble-effects (like Oddly Shaped Opal and Barriers) to more closely match the model.
			- Fixed some overlapping animations.
			- Tweaked the volume of some sounds.
			- Added a sound when picking Soldier in the menu.	
- `0.2.1`		
	- Made some fixes for the SotV update.		
- `0.2.0`	
	- Decreased the power of the Rocket Launcher slightly (800% -> 700%) 	
	- Decreased the power of the Shotgun slightly (9 x 70% -> 9 x 65%) and lowered Proc Coefficent (is now .5 per bullet) 	
	- Decreased the power of the Market Gardener (8000% -> 6000%) (I wanted to reign it in a bit, but still keep it satisfying to use) 	
	- Made the Concheror mobile/actionable. (note: actionable is something of an unintended side-effect) 	
	- Consolidated the Lifesteal buff into the actual conch buff 	
	- Reorganized and changed rocket jumping implementation to (hopefully) be more client-friendly. 	
- `0.1.7`  	
	- Increased the power of the Rocket Launcher significantly (500% -> 800%)  
	- Decreased the power of the Shotgun slightly (9 x 80% -> 9 x 70%)  
	- ~~Tweaked Rocket Jumping implementation in an effort to fix clientside Rocket Jumping~~  
- `0.1.6`  
	- Gave Soldier a janky ragdoll, that should fix the problems with players being locked in the death state	       	
- `0.1.5(Special Thanks to Blazer Nitrox from the Modding Discord for all the help with dealing with a bunch of issues on this one!)`     	  
	- ~~Added a promising potential fix for multiplayer rocket jumping.~~    
	- Added a promising potential fix for getting locked out of abilities.    
	- Tougher Times no longer blocks the knockback for rocket jumping.  
	- Increased the aim range for Soldier, allowing him to shoot straight up/down.  
	- Handled some issues with SkinUI.  
- `0.1.4`   
	- ~~Added another potential fix for multiplayer rocket jumping.~~ `Still no.`  	
	- Added a potential fix for being able to spam Primary and use the Special endlessly.  
	- Added a potential fix for items like Crowbar and Focus Crystal being activated when Rocket Jumping  
	- Fixed an 'issue' where the damage of the Rocket Launcher was using the wrong value (1600% -> 500%)  
	- Lowered the damage of the Shotgun (9 x 90% -> 9 x 80%)  
	- 
- `0.1.3`  
	- ~~Added a potential fix for multiplayer rocket jumping.~~  `Not Fixed Here!`  
	- ~~Added a potential fix for being locked out of using the Secondary / Special abilities after using the Utility.~~  `Not Fixed Here!`  
- `0.1.2`  
	- Tweaked the readme  
- `0.1.0`  
	- Initial Release  

